﻿
&Вместо("НастройкиОбменаДляУзлаИнформационнойБазы")
Функция исперп_НастройкиОбменаДляУзлаИнформационнойБазы(УзелИнформационнойБазы
	, ДействиеПриОбмене
	, ВидТранспортаСообщенийОбмена
	, ИспользоватьНастройкиТранспорта)
	
	Если НЕ исперп_Настройка
		.ПравкаВключена(исперп_Идентификатор.ОбменДаннымиСервер_НастройкиОбменаДляУзлаИнформационнойбазы()) Тогда
		Возврат ПродолжитьВызов(УзелИнформационнойБазы
		, ДействиеПриОбмене
		, ВидТранспортаСообщенийОбмена
		, ИспользоватьНастройкиТранспорта);
	КонецЕсли;
	
	// Возвращаемое значение функции.
	СтруктураНастроекОбмена = исперп_ОбменДаннымиСервер
	.СтруктураНастроекОбменаБазовая();
	
	СтруктураНастроекОбмена.УзелИнформационнойБазы = УзелИнформационнойБазы;
	СтруктураНастроекОбмена.ДействиеПриОбмене      = ДействиеПриОбмене;
	СтруктураНастроекОбмена.ВидТранспортаОбмена    = ВидТранспортаСообщенийОбмена;
	СтруктураНастроекОбмена.ЭтоОбменВРИБ           = исперп_Модуль.ОбменДаннымиПовтИсп().ЭтоУзелРаспределеннойИнформационнойБазы(УзелИнформационнойБазы);
	
	исперп_ОбменДаннымиСервер
	.ВыполнитьИнициализациюСтруктурыНастроекОбменаДляУзлаИнформационнойБазы(СтруктураНастроекОбмена, ИспользоватьНастройкиТранспорта);
	
	исперп_ОбменДаннымиСервер
	.УстановитьНастройкиРежимаОтладкиДляСтруктуры(СтруктураНастроекОбмена);
	
	// Проверяем структуру настроек на валидность значений для выполнения обмена. Ошибки фиксируем в ЖР.
	исперп_ОбменДаннымиСервер
	.ВыполнитьПроверкуСтруктурыОбменаНаВалидность(СтруктураНастроекОбмена, ИспользоватьНастройкиТранспорта);
	
	// Если настройки содержат ошибки, то выходим.
	Если СтруктураНастроекОбмена.Отказ Тогда
		Возврат СтруктураНастроекОбмена;
	КонецЕсли;
	
	Если ИспользоватьНастройкиТранспорта 
		// ::: +++
		// Вызывается из помощника синхронизации данных для операции
		// 	запроса состояния обмена по WS, выделенной обработки не имеет
		// 	и в объекте обработки нет необходимости, код уходит на другую ветку
		И НЕ (НРег(ДействиеПриОбмене) = НРег("ПроверкаСостоянияДлительнойОперации")
			И ВидТранспортаСообщенийОбмена = Перечисления.ВидыТранспортаСообщенийОбмена.WS
		)
		// ::: +++
		Тогда
		
		// Инициализируем обработку транспорта сообщений обмена.
		исперп_ОбменДаннымиСервер
		.ВыполнитьИнициализациюОбработкиТранспортаСообщенийОбмена(СтруктураНастроекОбмена);
		
	КонецЕсли;
	
	// Инициализируем обработку обмена данными.
	Если СтруктураНастроекОбмена.ЭтоОбменВРИБ Тогда
		
		исперп_ОбменДаннымиСервер
		.ВыполнитьИнициализациюОбработкиОбмена(СтруктураНастроекОбмена);
		
	ИначеЕсли СтруктураНастроекОбмена.ОбменПоПравиламКонвертацииОбъектов Тогда
		
		исперп_ОбменДаннымиСервер
		.ВыполнитьИнициализациюОбработкиОбменаПоПравиламКонвертации(СтруктураНастроекОбмена);
		
	КонецЕсли;
	
	Возврат СтруктураНастроекОбмена;
	
КонецФункции


